]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- Version: 1.560
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
f51bfb2f
ER
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
d54662bf 4
2b05614d 5# can be used by builder script to check for version
98c5c988
ER
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
e05017c1 8%epoch 0
3241033b 9%x8664 x86_64 amd64 ia32e
9c404149 10
ba1fdedc 11# kernel compiler
345d14e5 12%kgcc %{__cc}
d2e1bc22 13%kgcc_package gcc
ba1fdedc 14
46763914 15# compiler version
69bcfbf3 16%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 17%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 18
69bcfbf3 19%__rm /bin/rm --interactive=never
36eccf0d 20
33040789 21# Build system path macros.
69bcfbf3
ER
22%__autoconf autoconf %{?debug:-Wall}
23%__automake automake -a -c -f --foreign
24%__autopoint autopoint --force
25
26# add parallel build flags: -jN
a5656a95 27#
11ecb0a1
ER
28# if you want to disable parallel build do:
29# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
a5656a95 30#
11ecb0a1
ER
31%__make /usr/bin/make %{?_smp_mflags}
32%__scons /usr/bin/scons %{?_smp_mflags}
33%__waf /usr/bin/waf %{?_smp_mflags}
b8f83d42 34%__cmake /usr/bin/cmake
a5656a95
JR
35
36%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
37 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 38
83094b62 39%__gettextize { \
8a995cff 40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 41 gettextize --copy --force --no-changelog; \
97589b6e 42 else \
3241033b 43 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
44 fi; \
45 if [ ! -f po/Makevars ]; then \
3241033b 46 cp -f po/Makevars{.template,}; \
8a995cff 47 fi; \
8a995cff 48}
f93109a0 49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
fb59e475 52%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
c26f1b59 55%__libtoolize libtoolize --copy --force --install
33040789 56
751c2bdd
ER
57# topdir is where builder script lives,
58# fallback to old style if SPECS/SOURCES dirs were found.
59%_topdir %{expand:%%global _topdir %(
60 if [ -d SPECS -a -d SOURCES ]; then
61 # old style rpmdir: in topdir
df3151c2 62 pwd
751c2bdd
ER
63 elif [ -d ../SPECS -a -d ../SOURCES ]; then
64 # old style rpmdir: in subdir
df3151c2 65 cd ..; pwd
751c2bdd
ER
66 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67 # if old style rpm dir exist, go with it
68 echo $HOME/rpm; \
69 elif [ -x ../builder -a ! -d ../builder ]; then
70 # relative new style rpmdir: in package dir
df3151c2 71 cd ..; pwd
751c2bdd
ER
72 elif [ -x builder -a ! -d builder ]; then
73 # relative new style rpmdir: in packages
df3151c2 74 pwd
751c2bdd
ER
75 elif [ -x packages/builder -a ! -d packages/builder ]; then
76 # relative new style rpmdir: packages dir in current dir
df3151c2 77 cd packages; pwd
751c2bdd
ER
78 else
79 # fallback to new style rpmdir
80 echo $HOME/rpm/packages
81 fi; \
82)}%_topdir
1052b4b8 83
751c2bdd
ER
84# if %{_topdir}/SPECS exists, it's old style structure
85%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
1052b4b8
ER
87
88# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
89# if they don't exist assume we are having custom topdir (which is not named as
90# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
df3151c2
ER
91# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
92%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
93%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
94%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
384e1b2b 95
81e450f7
ER
96# The number of cvs changelog entries kept when building package.
97%_buildchangelogtruncate 20
98
6a5eda77 99%dependencytracking %{nil}
3241033b 100
e5da9169
ER
101# Relations between package names that cause dependency loops
102# with legacy packages that cannot be fixed. Relations are
103# specified as
104# p>q
105# where package p has a Requires: on something that package q Provides:
106#
107# XXX Note: that there cannot be any whitespace within the string "p>q",
108# and that both p and q are package names (i.e. no version/release).
109%_dependency_whiteout %{nil}
110
810fa5c4 111#-----------------------------------------------------------------
112#
113# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
114# BuildRequires: awk
115# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 116#
117# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 118# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
119# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 120# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 121# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 122#
123# Regular expressions are supported, but to avoid some character be treated
124# as regular expression it must be escaped twice.
125
126%filter_out \
7b6f1112 127 for (i = 1; i in I; i++) { A=0; \
810fa5c4 128 for (f in F) { \
129 if (I[i] ~ "^" F[f] "$") A=1; \
130 }; \
131 if (!A) printf(I[i] FS); \
132 }
133
134%rpmcflags %(awk 'BEGIN {
135 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 136 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 137 %{filter_out}
138}')
139
140%rpmcxxflags %(awk 'BEGIN {
09a90176 141 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
142 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 143 %{filter_out}
144}')
145
98e7f050
AM
146%rpmcppflags %(awk 'BEGIN {
147 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
148 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
149 %{filter_out}
150}')
151
810fa5c4 152%rpmldflags %(awk 'BEGIN {
c05a0741 153 split("%{?optldflags}",I);
810fa5c4 154 split("%{?filterout_ld}",F)
155 %{filter_out}
156}')
157
25f52d1a 158# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
159# but, don't use it, better use gcc as linker
160%ld_rpmldflags %(awk 'BEGIN {
161 split("%{rpmldflags}",F);
162 for (f in F) {
163 s = F[f];
164 if (s ~ /^-Wl,/) {
165 s = substr(s,5);
166 gsub(/,/," ",s);
167 };
168 printf(s FS);
169 };
170}')
171
8ef644e5 172#-----------------------------------------------------------------
173#
174# Generate a command which cleans environment, leaving only the
175# most important variables.
176# If any spec requires any additional environment it should
177# redefine %_preserve_env in following manner:
178#
179# # ADDITIONAL_VAR is required because [a good reason here]
82d10503 180# %define _preserve_env ADDITIONAL_VAR
8ef644e5 181
57ba0f59 182%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
8ef644e5 183
bb597f2b
AM
184# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
185%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
0bdc88ec 186 split("%{?_preserve_env}", P);
a363d727
ER
187 for (i in P) {
188 p = P[i];
82d10503
ER
189 if (!ENVIRON[p] || d[p]) {
190 continue;
8ef644e5 191 }
82d10503
ER
192 d[p] = 1;
193 split(ENVIRON[p], V, "");
194 val = p "=";
195 for (j = 1; j in V; j++) {
196 v = V[j];
197 if (v == q)
198 v = qq;
199 else if (v == "\\"")
200 v = q2q;
201 else if (v == "\\\\")
202 v = "\\\\\\\\";
203 else
204 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
205 val = val "" v;
206 }
207 printf(val " ");
8ef644e5 208 }
209}')
210
9c404149 211#-----------------------------------------------------------------
9f4ce098 212%configure2_13 { \
9c404149
AM
213 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
214 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
215 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 216 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 217 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 218 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 219 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
220 %{?__cc:CC="%{__cc}" ; export CC ; } \
221 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 222 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 223 --host=%{_target_platform} \
9c404149
AM
224 --prefix=%{_prefix} \
225 --exec-prefix=%{_exec_prefix} \
226 --bindir=%{_bindir} \
227 --sbindir=%{_sbindir} \
228 --sysconfdir=%{_sysconfdir} \
229 --datadir=%{_datadir} \
230 --includedir=%{_includedir} \
231 --libdir=%{_libdir} \
232 --libexecdir=%{_libexecdir} \
233 --localstatedir=%{_localstatedir} \
234 --sharedstatedir=%{_sharedstatedir} \
235 --mandir=%{_mandir} \
236 --infodir=%{_infodir} \
b6c5da52 237 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 238 %{dependencytracking} \
9c404149
AM
239}
240
39b9534b
ER
241%cmake { \
242CC="%{__cc}" \
243CXX="%{__cxx}" \
244CFLAGS="%{rpmcflags}" \
245CXXFLAGS="%{rpmcxxflags}" \
12513dc1 246LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
247%{__cmake} \
248}
249
89f4ca1f
ER
250%scons { \
251%{__scons} \
5c76736d
ER
252 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
253 CFLAGS="${CFLAGS:-%rpmcflags}" \
254 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
255 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 256 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
257 %{?__cc:CC="%{__cc}"} \
258 %{?__cxx:CXX="%{__cxx}"} \
259 libsuffix=%{_lib} \
260 prefix=%{_prefix} \
39b9534b
ER
261}
262
6339d32d 263# waf. see waf.spec
6339d32d 264%waf { \
6339d32d
ER
265CC="%{__cc}" \
266CXX="%{__cxx}" \
9e244007 267CPP="%{__cpp}" \
6339d32d
ER
268CFLAGS="%{rpmcflags}" \
269CXXFLAGS="%{rpmcxxflags}" \
270%{__waf} \
6339d32d
ER
271}
272
4a6b0d54 273#----------------------------------------------------------------
9bacbb5b 274#%configure_cache 0
fe6c4bdd 275%configure_cache_file %{buildroot}.configure.cache
73f832b3 276
e84cd836 277%configure {./configure \
4a6b0d54
AF
278 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
279 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 280 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 281 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 282 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 283 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
284 %{?__cc:CC="%{__cc}"} \
285 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 286 --host=%{_target_platform} \
4a6b0d54
AF
287 --build=%{_target_platform} \
288 --prefix=%{_prefix} \
289 --exec-prefix=%{_exec_prefix} \
290 --bindir=%{_bindir} \
291 --sbindir=%{_sbindir} \
292 --sysconfdir=%{_sysconfdir} \
293 --datadir=%{_datadir} \
294 --includedir=%{_includedir} \
295 --libdir=%{_libdir} \
296 --libexecdir=%{_libexecdir} \
297 --localstatedir=%{_localstatedir} \
298 --sharedstatedir=%{_sharedstatedir} \
299 --mandir=%{_mandir} \
300 --infodir=%{_infodir} \
b6c5da52 301 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 302 %{dependencytracking} \
9bacbb5b 303 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
304}
305
611a25d5 306# Simple macros to simplify adding bconded options to configure scripts.
307# Each macro requires bcond name and accepts optional option name, if option
308# isn't specified bcond name is used as option name. Options returning
309# --with and --enable also allow third argument which will be added as value
310# ( --with-option=value or --enable-option=value ) in case or positive
311# condition, but won't be added otherwise ( nothing or just --disable-option ).
312
313# Requirements:
314# BuildRequires: rpmbuild(macros) >= 1.527
315
316# Usage example:
317# %{__enable bcond} - returns --enable-bcond iff build condition is set
318# %{__disable bcond option} - returns --enable-option iff bcond is not set
319# %{__enable_disable bcond option value} - returns --enable-option=value if
320# bcond is set, returns --disable-option otherwise
321
322# expand bconds to --enable-something and --disable-something
323%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
324%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
325%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
326
327# same as above, but condition inverted
328%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
329%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
330%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
331
332# expand bconds to --with-something and --without-something
333%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
334%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
335%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
336
337# same as above, but condition inverted
338%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
339%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
340%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
341
342#-----------------------------------------------------------------
343
b3b1397b
ER
344# overload to insert debuginfo package
345%prep \
346%if 0%{?_enable_debug_packages}\
347%{debug_package}\
348%endif\
349%%prep\
350%{nil}
351
9c404149 352# Location of autoconf macros
ef7d5e14 353%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
9c404149 354
e2804f99 355# Location of omf files
7f0f4a79 356%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 357
e987a186 358# Location of pkgconfig files
9a4e877a 359%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
360# noarch pkgconfig files
361%_npkgconfigdir /usr/share/pkgconfig
e987a186 362
486b0b5f 363# Location of desktop files
364%_desktopdir /usr/share/applications
86dff2d0 365%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 366
481463e9 367# Location of pixmaps for applnk/desktop files
e1f0a822 368%_pixmapsdir /usr/share/pixmaps
9c404149 369
481463e9 370# Location of themable icons for applnk/desktop files
b36c8e2a 371%_iconsdir /usr/share/icons
372
e987a186
JB
373# Location of fonts directories
374%_fontsdir /usr/share/fonts
375
b3282f3f 376# Location of Gtk and associated libraries documentation
fe6c4bdd 377%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 378
fc4d7771 379# Location of KDE documentation
fe6c4bdd 380%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 381
5869828c 382# unsermake script
383%__unsermake /usr/share/unsermake/unsermake
384
9c404149 385# Current date
8cf161e2 386%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 387
9c404149
AM
388# Example files, programs, scripts...
389%_examplesdir /usr/src/examples
390
c8f7e820 391# Alternative kernel type/version
261729d9 392%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 393
8377d27d 394# The directory holding Linux kernel sources
261729d9 395%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 396
c0fe61f0
ER
397# SysV-style initscripts dir
398%_initddir /etc/rc.d/init.d
399
9c404149 400# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 401%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 402
590bc1db 403# Bootstrap release macros.
404# Usage:
405# %bcond_with bootstrap
406# Release: %{bootstrap_release 1}
407#
408# Package will have release 1 if built normally,
409# and release 0.zzz.bootstrap if built with bootstrap
410%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
411
c924d9d8
ER
412# -n drm to generate kernel%{_alt_kernel}-drm dependency
413%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
414%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
415%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
8bf3719d 416
c924d9d8 417# -s post to generate Requires(post) dependency
63d9963a
ER
418%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
419%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
420%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 421
410df6e8
ER
422# Requires name = version-release
423%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 424# Requires: name = version
91d2f1eb 425%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 426# Requires: name = version (version based on querying package %2)
0d3e64c0 427%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 428
90c674d3
JR
429# Requires: name >= version
430%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
431# Requires: name >= version (version based on querying package %2)
432%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
433
c94807f3 434%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 435
436# kernel version-release handling
95125403 437%__kernel_ver %{expand:%%global __kernel_ver %( \\
acac3049 438 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
95125403
ER
439 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
440 echo ${Z:-ERROR}; \\
1a7d3518 441)}%__kernel_ver
95125403 442
c94807f3
ER
443%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
444%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
445%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
446%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 447
6262f001
ER
448# `uname -r` to be used in @release field
449%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
450
e00dd7f6 451# sgml macros
3241033b
ER
452%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
453%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
454%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
455%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
456%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
457%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 458%docbook_sgmlcat_fix() { for l in \
459'' \
460' -- default decl --' \
461'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
462' -- hacks for opensp --' \
463'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
464'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
465'' \
466; do echo $l; done >> %1 \
467}
468
eea64748
ER
469# vim - "
470
4f044018
ER
471# minimum file size needed for compressed documents.
472# just smaller files than this get larger when compressed.
a88ae20f
ER
473# some stats:
474# - 0 byte file compressed was 25 bytes .gz
475# - 39 byte file was compressed as 57
476# - with test/test.spec@man 158 byte file was compressed also 158
477%_min_compress_bytes 159
4f044018 478
9c404149
AM
479#-----------------------------------------------------------------
480# find and gzip all files in %{_mandir} and %{infodir}
481#
482# Requires: xargs, find
483#
484#%no_install_post_compress_docs 1
485%__spec_install_post_compress_docs { \
53d5af13 486%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 487 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 488 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 489 echo "Compress man pages: $i"; \
4f044018
ER
490 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
491 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
492 find $RPM_BUILD_ROOT$i -type l | while read a; do \
493 m=$(readlink $a); \
494 rm -f $a; \
495 echo .so ${m##*/} > $a; \
496 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
497 done; \
4f044018 498 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
499 fi; \
500 done; \
728ad671
JB
501 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
502 echo "Compress info pages: %{_infodir}"; \
503 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
504 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
505 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 506 fi; \
53d5af13 507}; __spec_install_post_compress_docs } }
9c404149
AM
508
509#-----------------------------------------------------------------
510# Strip executable binaries and shared object files
511#
512# Requires: find, awk, strip, cut, xargs
513#
a2ad2754
JB
514# Special macros which affect this process:
515#%no_install_post_strip 1 # disable stripping at all
516#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
517#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
518#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
519#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
520#
9c404149 521%__spec_install_post_strip {%{!?debug: \
53d5af13 522%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 523if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
524 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
525 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
526 if [ "$modulelist" ]; then \
527 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 528 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
529 echo "$modulelist" | xargs -l512 chmod u+w; \
530 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
531 echo "DONE"; \
532 fi; \
eea64748 533 fi; \
0ac49134 534 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
535 if [ -n "$filelist" ]; then \
536 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
537 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
538 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 539 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 540 if [ -n "$elfexelist" ]; then \
4d5370ac 541 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
542 chmod u+w $elfexelist; \
543 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
544 echo "DONE"; \
545 fi; \
546 if [ -n "$elfsharedlist" ]; then \
4d5370ac 547 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
548 chmod u+w $elfsharedlist; \
549 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
550 echo "DONE"; \
551 fi; \
552 if [ -n "$archiveslist" ]; then \
4d5370ac 553 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
554 chmod u+w $archiveslist; \
555 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
556 echo "DONE"; \
557 fi; \
98a06bad 558 fi; \
0ac49134
ER
559 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
560 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
561 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 562 if [ -n "$filelist_all" ]; then \
4d5370ac 563 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 564 chmod u+w $filelist_all; \
f89ccb5f 565 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 566 echo "DONE"; \
9c404149 567 fi; \
f89ccb5f 568 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 569 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 570 chmod u+w $filelist_unneeded; \
f89ccb5f 571 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 572 echo "DONE"; \
8f74418b 573 fi; \
f89ccb5f 574 if [ -n "$filelist_debug" ]; then \
4d5370ac 575 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 576 chmod u+w $filelist_debug; \
f89ccb5f 577 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 578 echo "DONE"; \
9f0d4f36 579 fi; \
53d5af13 580fi; }; __spec_install_post_strip } } }
3241033b 581
fc5d7e20 582#-----------------------------------------------------------------
583# remove all RPATH from executable binaries and shared object files
584#
585# Requires: find, awk, cut, xargs, chrpath, uname
586#
a2ad2754
JB
587# Special macros which affect this process
588#%no_install_post_chrpath 1 # disable chrpath at all
589#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
590#
fc5d7e20 591%__spec_install_post_chrpath {%{!?debug: \
53d5af13 592%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 593if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 594 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 595 if [ -n "$files" ]; then \
d5517264 596 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 597 fi; \
98a06bad 598 if [ -n "$objs" ]; then \
4d5370ac 599 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
600 echo "$objs" | \
601 while read file; do \
602 rpath= ; \
603 chmod u+w "$file"; \
5541bf26 604 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
605 case $dir in \
606 '$ORIGIN' ) \
607 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
608 else rpath="$rpath:$dir" ; fi ; \
609 continue ; \
610 ;; \
611 esac ; \
f9abaddb
AM
612 newdir=$(readlink -m "$dir"); \
613 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
614 case $dir in \
615 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
616 echo "remove-rpath: $dir in $file"; \
617 ;; \
618 * ) \
619 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
620 else rpath="$rpath:$dir" ; fi ; \
621 ;; \
622 esac ; \
623 done ; \
624 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
625 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
626 done; \
627 fi; \
53d5af13 628fi; }; __spec_install_post_chrpath } } }
3241033b 629
611a25d5 630# vim: "
631
d366d7e0
AM
632#-----------------------------------------------------------------
633# Find all shared object files with unresolved symbols. Warn
634# and terminate if any found (termination can be turned off by define).
635#%no_install_post_check_so 1
636%__spec_install_post_check_so { \
637 __spec_install_post_check_so() { \
638 fail=0; \
639 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 640 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 641 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
642 done ; \
643 echo " DONE"; \
14ae3117 644 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
645}; __spec_install_post_check_so }}
646
d72c185f 647#-----------------------------------------------------------------
ccb8ae8d 648# Find and gzip all kernel modules
649#
650# Requires: find
651#
fe6c4bdd 652#%no_install_post_compress_modules 1
ccb8ae8d 653%__spec_install_post_compress_modules { \
53d5af13 654%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 655 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 656 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
657 if [ "$q" ]; then \
658 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
659 echo "$q" | xargs -r %{__gzip} -9nf; \
660 echo "DONE"; \
661 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
662 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
663 fi; \
3241033b 664 fi; \
53d5af13 665}; __spec_install_post_compress_modules } }
9c404149 666
ef64802f
ER
667# Remove common Perl files we don't package
668%__spec_install_post_perl_clean {\
669%{!?no_install_post_perl_clean: \
670%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
671} }
672
83094b62 673#-----------------------------------------------------------------
0e4cb4dd 674# Update GConf2 schemas
83094b62 675#
676# Requires: GConf2
677#
46885239 678%gconf_schema_install() \
307ac6c9
ER
679 umask 022; \
680 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
681 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 682%{nil}
46885239 683
684%gconf_schema_uninstall() \
24336a54 685if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 686 umask 022; \
24336a54
ER
687 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
688 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 689fi; \
f93109a0 690%{nil}
691
692#-----------------------------------------------------------------
693# Update desktop MIME database
c0a4caa0 694# requires: desktop-file-utils
c3bcd10e 695%update_desktop_database() {{ \
f93109a0 696 umask 022; \
fb59e475 697 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
698};} \
699%{nil}
f93109a0 700
c3bcd10e
ER
701%update_desktop_database_post %update_desktop_database
702
703%update_desktop_database_postun() {{ \
f27cf2fd 704if [ "$1" = "0" ]; then \
c00bf95c 705 %update_desktop_database \
f27cf2fd 706fi; \
c00bf95c
MB
707};} \
708%{nil}
f93109a0 709
fb59e475 710#-----------------------------------------------------------------
711# Update shared MIME info database
712# requires: shared-mime-info
713#
c3bcd10e 714%update_mime_database() {{ \
fb59e475 715 umask 022; \
716 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
717};} \
718%{nil}
fb59e475 719
720#-----------------------------------------------------------------
721# Update icon cache
722# requires: gtk+
723#
c3bcd10e 724%update_icon_cache() {{ \
fb59e475 725 umask 022; \
072f4b80 726 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
727};} \
728%{nil}
fb59e475 729
f93109a0 730#-----------------------------------------------------------------
731# Update scrollkeeper database
732# requires: scrollkeeper
733#
734%scrollkeeper_update_post() \
f93109a0 735 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 736%{nil}
f93109a0 737
738%scrollkeeper_update_postun() \
f27cf2fd 739if [ "$1" = "0" ]; then \
f93109a0 740 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 741fi; \
f93109a0 742%{nil}
743
9c404149
AM
744#-----------------------------------------------------------------
745# post %install sequence:
746# - autodeps exceptions
747# - compress all man and info pages,
748# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 749# - compress kernel modules if any
9c404149
AM
750
751###################################################################
752# Requires/Provides automation
3e202b06 753# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 754#
2892b5df
JB
755%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
756%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
757%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
758%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
759%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 760
338726a6
JB
761#%_noautocompressdoc %{nil}
762#
8f74418b
MM
763%_missing_doc_files_terminate_build 1%{nil}
764%_unpackaged_files_terminate_build %{nil}
8781dc74 765# (X)emacs support
d77dcb61 766%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
767%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
768%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 769
02b58f60
JK
770%__php_provides %{nil}
771%__php_requires %{nil}
772%__perl_provides %{nil}
773%__perl_requires %{nil}
fa3497cd 774%__mono_provides %{nil}
775%__mono_requires %{nil}
25043cd4
AF
776
777# Perl specific macro definitions.
c94807f3
ER
778%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
779%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
780%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
781%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
782%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
783%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 784
45c00b39 785# Ruby
c94807f3
ER
786%__ruby /usr/bin/ruby
787%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
788%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
789%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
790%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
791%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
792%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
793%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 794%ruby_rdocdir /usr/share/rdoc
c94807f3 795%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
796%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
797%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 798
7ccf7643 799%php_pear_dir /usr/share/pear
7813c433 800%php_data_dir /usr/share/php
c94807f3
ER
801%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
802%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
803%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 804
0c5d1b9b 805# extract php/zend api versions
c94807f3 806%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
e0d35dd1 807%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
c94807f3
ER
808%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
809%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
810%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
811%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
812%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
813%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
814
815# helper macro
f952c0f3 816%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
817
818# macros for public use
819# for php extensions (php-pecl)
68b68193 820%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 821%{__php_api_requires zend_module_api} \
f952c0f3
ER
822%{__php_api_requires -v %php_major_version debug php_debug} \
823%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 824
c1b2705c
ER
825# for zend extensions
826%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 827%{__php_api_requires zend_extension_api} \
f952c0f3
ER
828%{__php_api_requires -v %php_major_version debug php_debug} \
829%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 830
934c685f
ER
831# for php pdo modules (php-pecl-PDO_*)
832%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
833
6c3b8203
ER
834# for using PHP post scripts. for PHP >= 5.0
835%php_webserver_restart \
836[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 837[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
8e2cfc36 838if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
839 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
840 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
841 %service -q php-fcgi restart \
842 fi \
843fi \
8e2cfc36
ER
844if [ -x /etc/rc.d/init.d/php-fpm ]; then \
845 %service -q php-fpm restart \
846fi \
6c3b8203
ER
847%{nil}
848
849# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
850%php4_webserver_restart \
851[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 852[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
8e2cfc36 853if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
ba1800dc
ER
854 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
855 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
856 %service -q php-fcgi restart \
857 fi \
858fi \
6c3b8203
ER
859%{nil}
860
578e9248 861# X.org helper macros
434ab5a2
ER
862%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
863%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
864
c94807f3
ER
865%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
866%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
867%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
868%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
869%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
611a25d5 870# vim: '
578e9248 871
434ab5a2 872%requires_xorg_xserver_extension \
97486460
AM
873%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
874%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
875%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
876%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
877%{nil}
878
879%requires_xorg_xserver_xinput \
97486460
AM
880%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
881%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
882%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
883%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
884%{nil}
885
886%requires_xorg_xserver_font \
97486460
AM
887%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
888%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
889%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
890%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
891%{nil}
892
893%requires_xorg_xserver_videodrv \
97486460
AM
894%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
895%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
896%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
897%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 898%{nil}
578e9248 899
15d7cc4a
ER
900# TCL specific macro definitions.
901# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
902%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
903%tcl_sitearch %{_libdir}/tcl%{tcl_version}
904%tcl_sitelib %{_datadir}/tcl%{tcl_version}
905
25043cd4
AF
906# Python specific macro definitions.
907# python main version
2383a9da 908%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
909
910# directories
2383a9da 911%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 912%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 913%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 914%py_incdir /usr/include/python%{py_ver}
7ccf7643 915%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 916%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 917%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
918
919# pure python modules compilation
3241033b 920%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 921
3241033b 922%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
923
924# Software written in Python language require Python with main version
e63cd81d 925%pyrequires_eq() Requires: %1
25043cd4 926
4bf34b55
AF
927# Python 3.x
928# python main version
e9f00395 929%__python3 python3
4bf34b55
AF
930%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
931
932# directories
933%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
934%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
935%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
936%py3_incdir /usr/include/python%{py3_ver}
937%py3_sitedir %{py3_libdir}/site-packages
938%py3_sitescriptdir %{py3_scriptdir}/site-packages
939%py3_dyndir %{py3_libdir}/lib-dynload
940
941# pure python modules compilation
942%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
943
944%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
945
f12c2314 946# Hardlink binary identical .pyc and .pyo files
f12c2314 947%__spec_install_post_py_hardlink {\
53d5af13 948%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
949local a b c=0 t=0; \
950if [ -d "$RPM_BUILD_ROOT" ]; then \
951 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
952 while read a; do \
953 b="${a%.pyc}.pyo"; \
954 if cmp -s "$a" "$b"; then \
955 ln -f "$a" "$b"; \
956 c=$((c + 1)); \
957 fi; \
958 t=$((t + 1)); \
959 done < __rpm_pyc; \
960 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
961 rm -f __rpm_pyc; \
962fi; \
53d5af13 963}; __spec_install_post_py_hardlink } }
f12c2314 964
9227b3f9 965# remove python sources, so that check-files won't complain
f12c2314 966%py_postclean() \
0f82e280 967for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 968 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
969done \
970%{nil}
971
4bf34b55
AF
972%py3_postclean() \
973for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
974 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
975done \
976%{nil}
977
0fc5cff8 978# depmod macro
979%depmod() { \
f6148427 980umask 022; \
0fc5cff8 981if [ -e /boot/System.map-%1 ]; then \
3241033b 982 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 983else \
3241033b
ER
984 if [ -e /boot/System.map ]; then \
985 /sbin/depmod -a -F /boot/System.map %1; \
986 else \
987 /sbin/depmod -a %1; \
988 fi \
0fc5cff8 989fi; \
990}
991
2afc6e64 992# XMMS specific macros
c94807f3
ER
993%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
994%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
995%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
996%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
997%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
998%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
999%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1000%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1001%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1002%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1003
c28a1d6a 1004%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/')}%_target_base_arch
d1537778 1005
848c0d68 1006# user/group checking macros
1007#
1008# Usage:
1009# %userremove myuser
1010#
1011%userremove /usr/lib/rpm/user_group.sh user del
1012%groupremove /usr/lib/rpm/user_group.sh group del
1013#
1014# Usage:
1015# if %usertestrm myuser; then
1016# /usr/sbin/userdel -r myuser
1017# Note:
1018# use these macros only if you need to call userdel/groupdel with
1019# a non-standard option or take an extra action; otherwise use the
1020# %userremove/%groupremove macros
1021#
1022%usertestrm /usr/lib/rpm/user_group.sh user testrm
1023%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
1024# user group membership management macros
1025#
1026# Usage:
efbc7726 1027# %addusertogroup [-q] myuser agroup
08d9b1f6 1028#
efbc7726
ER
1029# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1030#
1031# Requirements:
1032# BuildRequires: rpmbuild(macros) >= 1.515
2b29e157
ER
1033%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1034%{nil}
72fcfcb3 1035
1036# banner support (useful in {pre,post}{,un} and triggers)
1037#
1038# Usage:
aa41c920 1039# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 1040# the banner text, the banner text
aa41c920
ER
1041# the banner text, and following line
1042#EOF
1043# You can use any form of here-document, <<'EOF' <<-EOT will do.
1044# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1045#
72fcfcb3 1046# -a - append to the banner
a8b9562a 1047# -e - send to stderr instead of stdout
628754cb 1048# -n - no show banner (overrides -t)
1049# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
1050#
1051# Tests:
1052# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1053# rpm -E 'date | %banner -e banner' > m; sh -x m
1054#
afb54f6c 1055%banner(aent:) ( \
1b334fe4 1056RPM_SCRIPTVERBOSITY=5 \
1057[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1058if [ -x /usr/bin/banner.sh ]; then \
aa41c920 1059 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 1060else \
a8b9562a 1061 CMD="cat%{-e: >&2}" \
1b334fe4 1062fi \
276a7b45
ER
1063eval $CMD %{?2:%2}%{?3: %3}) \
1064%{nil}
628754cb 1065
990bd03f 1066# useradd/groupadd macros
4c73bc69 1067# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
1068#
1069# Usage:
1070# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1071# [-g initial_group] [-G group[,...]] login
1072#
1073# -u uid. REQUIRED
1074# -g gid/group. REQUIRED
1075# -s defaults to /bin/false
1076# -d defaults to /usr/share/empty
1077# -c No default
1078# -r is accepted but ignored (it's always set)
6bd4c218 1079# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
1080# rpm specific flags
1081# -P package name. defaults to %{name}
1082#
90627280 1083%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
1084%{!-u:%{error:useradd: Required argument -u missing}} \
1085%{!-g:%{error:useradd: Required argument -g missing}} \
1086%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
1087if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1088 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1089 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1090 exit 1 \
1091 fi \
1092else \
1093 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1094 /usr/sbin/useradd \\\
b5a7d552 1095 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
1096 -u %{-u*} \\\
1097 -r \\\
1098 -d %{-d*}%{!-d:/usr/share/empty} \\\
1099 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 1100 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
1101 -g %{-g*} \\\
1102 %{-M} \\\
1103 %{-G:-G %{-G*}} \\\
1aac682a 1104 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 1105 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280 1106fi;
611a25d5 1107# vim: "
90627280 1108
90627280
ER
1109# Usage:
1110# %groupadd [-P package] [-g gid] group
1111#
1112# -g gid. REQUIRED
1113#
1114# Sample:
1115# %groupadd -P %{name}-base -g %{gid} %{name}
1116
1117%groupadd(g:P:rfo) \
9ba02ba9
ER
1118%{!-g:%{error:groupadd: Required argument -g missing}} \
1119%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1120if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1121 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1122 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1123 exit 1 \
1124 fi \
1125else \
1126 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1127 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1128 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1129fi;
7cb77741 1130
7c50f037 1131# webapp macros
4c73bc69 1132# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1133#
1134# The config is installed/removed inside trigger, this means that you can any
1135# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1136# updated. if you don't need the config for various reason for specific
35663282
ER
1137# webserver, just remove the symlink from config directory using webapp
1138# program. the trigger will not recreate the symlink on upgrades. In other
1139# words the config is linked to webserver config directory on first install of
1140# PACKAGE or WEBSERVER.
1141#
7c50f037
ER
1142# Add package's webserver config to webserver webapps dir.
1143# Usage:
aea687a7 1144# %webapp_register [-f] WEBSERVER WEBAPP
35663282 1145#
aea687a7 1146%webapp_register(f) \
35663282 1147%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
aea687a7 1148if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
35663282
ER
1149 /usr/sbin/webapp register %1 %2\
1150fi\
694a8f2e 1151# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1152if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1153 %{expand:%service -q %%1 reload}\
35663282
ER
1154fi\
1155%{nil}
1156
1157# Remove package's config from webserver webapps dir.
35663282 1158# Usage:
531c0efc
ER
1159# %webapp_register [-f] WEBSERVER WEBAPP
1160%webapp_unregister(f) \
35663282
ER
1161%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1162# remove link if either of the packages are gone \
5d3a09a3 1163if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1164 /usr/sbin/webapp unregister %1 %2\
16897aea 1165 %{expand:%service -q %%1 reload}\
35663282
ER
1166fi \
1167%{nil}
1168
462b26fa 1169# service macro.
4c73bc69 1170# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1171#
1172# calls usual service restart on package %post, but skips the restart if
1173# administrator has disabled automatic service restarts in either global
1174# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1175#
462b26fa 1176# Usage:
7377b5ca 1177# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1178#
a0bbe604 1179# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1180# -n NOOP mode, do not actually restart service
462b26fa 1181#
7377b5ca
ER
1182# Requirements:
1183# BuildRequires: rpmbuild(macros) >= 1.268
1184# Requires: rc-scripts
1185# -n option:
1186# BuildRequires: rpmbuild(macros) >= 1.450
1187%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1188
1189
f9aa75bf
ER
1190# Java macros. based on jpackage macros.java
1191#
1192# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1193%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1194
1195# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1196%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1197
1198# Root directory for all Java VM/SDK/JRE's private things.
1199%_jvmprivdir %{_libdir}/jvm-private
1200
1201# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1202%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1203
1204# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1205%_jvmdatadir %{_datadir}/jvm
1206
1207# Root directory for all configurations parts of Java VM/SDK/JRE's
1208%_jvmsysconfdir %{_sysconfdir}/jvm
1209
1210# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1211%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1212
1213# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1214%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1215
1216# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1217%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1218
1219# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1220%_jnidir %{_libdir}/java
f9aa75bf 1221
ed644e79
JK
1222
1223# JDK selection. Set this to name of the JDK implementation to use
1224# insead of the system default
1225#%use_jdk icedtea6
1226
1227# expands to the value with right jdk for BuildRequires header
1228# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1229# The requirement will not replace current 'default' JDK
1230%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1231
1232%buildrequires_jdk BuildRequires: %required_jdk
1233
1234%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1235
e0e23dcd 1236%_javasrcdir %{_usrsrc}/java
1237
a9254650 1238%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1239%jar %{java_home}/bin/jar
ed644e79 1240%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
fe6c4bdd
ER
1241%javac %{java_home}/bin/javac
1242%javadoc %{java_home}/bin/javadoc
6aedae62 1243
fe6c4bdd 1244%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1245
1246%jpackage_script() \
3ca65b87
ER
1247install -d $RPM_BUILD_ROOT%{_bindir}\
1248cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1249#!/bin/sh\
1250#\
1251# %{name} script\
1252# JPackage Project <http://www.jpackage.org/>\
1253\
1254# Source functions library\
1255. %{_javadir}-utils/java-functions\
1256\
1257# Source system prefs\
3ca65b87 1258if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1259 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1260fi\
1261\
1262# Source user prefs\
3ca65b87
ER
1263if [ -f $HOME/.%{name}rc ]; then\
1264 . $HOME/.%{name}rc\
6aedae62
ER
1265fi\
1266\
1267# Configuration\
1268MAIN_CLASS=%1\
1269BASE_FLAGS=%2\
1270BASE_OPTIONS=%3\
3ca65b87 1271BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1272\
1273# Set parameters\
1274set_jvm\
3ca65b87
ER
1275set_classpath $BASE_JARS\
1276set_flags $BASE_FLAGS\
1277set_options $BASE_OPTIONS\
6aedae62
ER
1278\
1279# Let's start\
3ca65b87 1280run "$@"\
6aedae62
ER
1281EOF
1282
06f11871
ER
1283# jpackage 1.7
1284# Directory for maven depmaps
1285#
1286%_mavendepmapdir /etc/maven
1287%_mavendepmapfragdir /etc/maven/fragments
1288
1289#
1290# add_to_depmap adds an entry to the depmap. The arguments are:
1291#
1292# %1 the original groupid
1293# %2 the original artifact id
1294# %3 the version
1295# %4 the new groupid
1296# %5 the new artifactid
1297#
1298
1299%add_to_maven_depmap() \
1300install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1301cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1302<dependency>\
1303 <maven>\
1304 <groupId>%1</groupId>\
1305 <artifactId>%2</artifactId>\
1306 <version>%3</version>\
1307 </maven>\
1308 <jpp>\
1309 <groupId>%4</groupId>\
1310 <artifactId>%5</artifactId>\
1311 <version>%3</version>\
1312 </jpp>\
1313</dependency>\
1314\
1315EOF\
1316%{nil}
1317
1318#==============================================================================
1319#
1320# update_maven_depmap updates the main maven depmap
1321#
1322%update_maven_depmap() \
1323echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1324if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1325cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1326fi\
1327echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1328
02c5f99a 1329# JAVA macros specific for PLD
1330
1331# Directory for tomcat context configuration files
1332%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
06f11871 1333
89c2423f 1334# Tomcat cache path
1335%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1336
1337# Clear tomcat cache
1338# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1339#
1340# Usage:
1341# %%tomcat_clear_cache appname
1342#
e09b1b1b 1343# Call this script in %postun scriptlet. It will remove compiled jsps related to
89c2423f 1344# given app.
1345#
1346%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1347
59d3ebe9 1348# PEAR install macros
4c73bc69 1349# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1350#
1351# Usage:
f7ecf326 1352# %%pear_package_setup ...
dfce8b19 1353#
59d3ebe9 1354# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1355# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1356# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1357# -D - pass -D to %setup (so the build dir is not removed)
1358# -c - register channel from local channel.xml file
dfce8b19
ER
1359#
1360# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1361# destination hierarchy. you should copy the tree to buildroot after
1362# patching/reorganizing with %%pear_package_install.
1363#
1364# additionally BUILDROOT is stripped from files and files are converted to UNIX
1365# line endings.
1366#
1367# the pear install process output is recorded to install.log, you should put it
8763f51e 1368# to %%doc for later debug or just for information.
dfce8b19
ER
1369#
1370# additionally additional-packages.txt is produced if it was detected that the
1371# package has optional dependencies. the file format is suitable of displaying
1372# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1373# automatically added for this file.
59d3ebe9
ER
1374
1375
1376# records install.log and transforms PEAR names to PLD Linux rpm package names.
1377%__pear_install_log \
1378tee install.log \
1379# make post message of optional packages \
f64d1bb2 1380grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1381if [ -s optional-packages.txt ]; then \
1382 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1383else \
1384 rm -f optional-packages.txt \
1385fi \
1386%{nil}
1387
1388# command invoking pear cli
1389%__pear /usr/bin/pear
1390
67a089ff 1391%pear_install(a:n:zD) \
59d3ebe9 1392%__pear \\\
f7ecf326 1393 -c %{builddir}/pearrc \\\
dfce8b19 1394 -d doc_dir=/docs \\\
f7ecf326
ER
1395 -d temp_dir=/tmp \\\
1396 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1397 -d bin_dir=%{_bindir} \\\
1398 -d data_dir=%{php_pear_dir}/data \\\
1399 -d test_dir=%{php_pear_dir}/tests \\\
1400 install \\\
59d3ebe9 1401 --packagingroot=%{builddir} \\\
dfce8b19
ER
1402 --offline \\\
1403 --nodeps \\\
1404 %{-f:--force} \\\
67a089ff 1405 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1406 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1407%{nil}
1408
1409# The main macro.
1410# using this macro will append optional-packages.txt to the nocompressdoc list
1411# as it's displayed to user after package install. and adding additional gzip
1412# dep is just waste ;)
f7ecf326 1413%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1414%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1415%define builddir %{_builddir}/%{srcdir} \
1416%setup -q -c -T %{-D:-D} -n %{srcdir} \
1417%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1418%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1419%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1420%pear_install \
59d3ebe9
ER
1421%{-z:cd ..} \
1422cat %{-z:$_N/}.install.log | %__pear_install_log \
1423\
dfce8b19 1424# undos sources \
2a80e4cf 1425find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1426%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1427%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1428%{nil}
1429
7bef60e8 1430# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1431# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1432%pear_package_install() \
1433cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1434find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1435# help the developer out a little: \
1436if [ -f _noautoreq ]; then \
1437 echo "AutoReqdep detected:" \
1438 echo "_noautoreq $(cat _noautoreq)" \
1439fi \
1440%{nil}
1441
0d5dd00c
ER
1442
1443# Register OpenLDAP schema.
4c73bc69 1444# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1445#
1446# Usage:
1447# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1448#
1449# -d specify dependant schemas, separated by comma
1450#
1451%openldap_schema_register(d:) \
1452for schema in %*; do \
1453 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1454 %{__sed} -i -e " \
1455 /^include.*local.schema/{ \
1456 iinclude\\t $schema\
1457 } \
1458 " /etc/openldap/slapd.conf \
1459 fi \
1460done \
1461# enable dependant schemas \
1462if [ "%{-d*}" ]; then \
1463 %{__sed} -i -e ' \
1464 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1465 s/^#// \
1466 }' /etc/openldap/slapd.conf \
1467fi \
1468%{nil}
1469
1470# Unregister OpenLDAP schema.
4c73bc69 1471# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1472#
1473# Usage:
1474# %%openldap_schema_unregister %{schemadir}/horde.schema
1475#
1476%openldap_schema_unregister() \
1477for schema in %*; do \
1478 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1479 %{__sed} -i -e " \
1480 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1481 # for symmetry it would be nice if we disable enabled schemas in post, \
1482 # but we really can not do that, it would break something else. \
1483 " /etc/openldap/slapd.conf \
1484 fi \
1485done \
1486%{nil}
1487
b0bc2936 1488%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1489
dcc6baf7 1490
1491# Build modules for kernels 2.6
1492# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1493#
1494# Usage:
aa559e46 1495# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1496#
1497# remember that proper Makefile is still required
1498# Options:
990bd03f 1499# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1500# without .ko extension, may be placed in subdirectory
aa559e46 1501# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1502# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1503# -c -- do not execute make clean
dcc6baf7 1504# <additional arguments> -- all additional arguments will be passed to
1505# make modules
1506#
1507# Additional patching supported via here document. Try:
1508# %build_kernel_modules -m module <<'EOF'
1509# your patch script here
1510# EOF
1511# Don't use it unless patching depends on config options.
1512
1513# Developer note: don't touch it unless you know how to handle '\'.
1514# - \ in script expands to nothing
1515# - \\\ in script expands to \
566398b4 1516# - \\\ inside definition expands to nothing
dcc6baf7 1517# - \\\\\\\ inside definition expands to \
1518# - in last line \ has to touch arguments so arguments passing
1519# in new lines (using \) will be supported
1520
5a81d83e 1521%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1522%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1523 \
1524%define Opts \\\\\\\
1525%if "%{_target_base_arch}" != "%{_arch}" \\\
1526 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1527 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1528 %else \\\
1529 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1530 %endif \\\
1531%else \\\
88608ef7 1532 CC="%{kgcc}" \\\
dcc6baf7 1533%endif \
88608ef7 1534%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1535 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1536 \
e364bc26 1537%{?-C:cd %{-C*}} \
dcc6baf7 1538compile() { \
ba9de9b2
ER
1539 local L="<" PATCH_SH; \
1540 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1541 set -e -x \
730239f9 1542 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1543 \
730239f9 1544for cfg in ${cfgs:-dist}; do \
dcc6baf7 1545 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1546 \
c546f6fb 1547 rm -rf o \
ec8cb195 1548 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
dcc6baf7 1549 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1550 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
ec8cb195
AM
1551 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1552 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
a2a36b0c 1553 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
ec8cb195
AM
1554 else \
1555 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1556 fi \
dcc6baf7 1557 \
1558 set +x \
1559 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1560 set -x \
1561 \
c768535c 1562 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1563 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1564 %{-p*} %{-P*} \\\
1565 %{MakeOpts} \
1566 %else \
1567 install -d o/include/config \
1568 touch o/include/config/MARKER \
588f1b0b 1569 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1570 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1571 %endif \
1572 \
5a81d83e 1573 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1574 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1575 ${1+"$@"} \\\
5a81d83e 1576 M=$PWD %{MakeOpts}} \
f635907b 1577 \
dcc6baf7 1578 %{__make} -C %{_kernelsrcdir} modules \\\
1579 ${1+"$@"} \\\
1580 M=$PWD %{MakeOpts} \
1581 \
1582 for MODULE in {%{-m*},}; do \
1583 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1584 done \
1585done \
aa559e46 1586%{?-C:cd -} \
dcc6baf7 1587} \
1588compile %{*}\
1589%{nil}
1590
1591
1592# Install kernel modules built by %build_kernel_modules
1593# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1594#
1595# Usage:
1596# %install_kernel_modules -m <modules> -d <directory>
1597#
1598# Options:
990bd03f 1599# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1600# without .ko extension, may be placed in subdirectory
1601# -d <directory> (required) -- in what subdirectory modules should be
1602# installed (eg. misc, kernel/drivers/net)
1603# -s <suffix> -- suffix to use when installing modules, useful when module
1604# with same name exists in kernel already
1605# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1606# for defining aliases, only useful with -s
dcc6baf7 1607
1608%install_kernel_modules(m:d:s:n:) \
1609%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1610%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1611%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1612 \
1613%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1614%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1615 \
b279feda 1616__install_kernel_modules() { \
730239f9 1617local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1618 \
1619for MODULE in {%{-m*},}; do \
1620 [ -n "${MODULE}" ] || continue \
730239f9
ER
1621 for cfg in ${cfgs:-dist}; do \
1622 [ "$cfg" = smp ] && suf=smp || suf= \
1623 MNAME=${MODULE##*/} \
1624 install -D ${MODULE}-$cfg.ko \\\
1625 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1626 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1627 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1628 >> %{ModprobeD}$suf/%{-n*}.conf} \
1629 done \
dcc6baf7 1630done \
b279feda 1631} \
1632__install_kernel_modules \
dcc6baf7 1633%{nil}
1634
fa65356c 1635# patchset macros
4c73bc69 1636# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1637#
1638# Usage:
1639# %patchset_source -f <seq(1) format> <start> [<end>]
1640# %patchset_patch <start> [<end>]
1641#
1642# If <end> is omited, it is assumed to be <start>.
1643#
1644# For example in preamble:
1645# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1646# and in %prep:
1647# %patchset_patch 33 44
1648
1649# generate SourceX urls from range START STOP
1650# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1651# The sources start from 10000
e91610db 1652%patchset_source(f:b:) %(
44f733ef 1653 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1654 start=$(expr $base + %1);
1655 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1656 # we need to call seq twice as it doesn't allow two formats
1657 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1658 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1659 paste %{tmpdir}/__ps{1,2};
1660 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1661) \
1662%{nil}
fa65356c
ER
1663
1664# apply sources from %patchset_source
1665# -p specify -pX for %patch line
1666# -b base offset: defaults to 10000
1667%patchset_patch(f:p:b:) %(
44f733ef 1668 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1669 start=$(expr $base + %1);
1670 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1671 echo ": patchset_patch %1%{?2: to %2}";
1672 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1673) \
1674%{nil}
fa65356c 1675
5730b44b 1676# browser plugins v2
4c73bc69 1677# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1678#
1679# Usage:
1680# %browser_plugins_add_browser <name> -p <plugindir>
1681#
1682# <name> (required) -- name of the browser. usually %{name}.
1683# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1684# -b -- default blacklists
1685# -a <arch> override arch
5730b44b
ER
1686#
1687# Example:
1688# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1689
1690%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1691%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1692%update_browser_plugins /usr/sbin/update-browser-plugins || :
1693
02ebf70f 1694%browser_plugins_add_browser(p:b:a:) \
9efd458e 1695 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1696 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1697 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1698 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1699 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1700 %{-b:cat >> $blacklist_file %{-b*}} \
1701%{nil}
1702
ad17b654
ER
1703# Helper for LUA.
1704# split string separated by space into quoted list
1705#
4c73bc69 1706# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1707#
1708# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1709%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1710
1711# adjust /etc/shells by adding and removing shells from there
4c73bc69 1712# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1713#
1714# Usage:
d9b789d9
ER
1715# %post -p <lua>
1716# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1717#
d9b789d9
ER
1718# %preun -p <lua>
1719# if arg[2] == 0 then
1720# %lua_remove_etc_shells /bin/bash /bin/rbash
1721# end
7377b5ca
ER
1722#
1723# Requirements:
d9b789d9
ER
1724# BuildRequires: rpmbuild(macros) >= 1.462
1725#
ad17b654 1726
d9b789d9 1727%lua_add_etc_shells() \
ad17b654
ER
1728t = {}\
1729f = io.open("/etc/shells", "r")\
1730if f then\
1731 for l in f:lines() do t[l]=l; end\
1732 f:close()\
1733end\
1734for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1735 if not t[s] then\
b8c0bc18 1736 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1737 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1738 end\
1739end\
1740%{nil}
1741
d9b789d9
ER
1742%lua_remove_etc_shells() \
1743t = {}\
1744f = io.open("/etc/shells", "r")\
1745if f then\
1746 for l in f:lines() do t[l]=l; end\
1747 f:close()\
1748end\
1749for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1750 print("Removing "..l.." from /etc/shells")\
1751 t[l] = nil\
1752end\
1753s=""\
1754for _, l in pairs(t) do\
1755 s=s..l.."\\n"\
1756end\
1757io.open("/etc/shells", "w"):write(s)\
1758%{nil}
1759
1760# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1761#
1762# Author: Elan Ruusamäe <glen@pld-linux.org>
1763#
1764# Usage:
1765# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1766# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1767#
1768# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1769#
1770# Requirements:
1771# BuildRequires: rpmbuild(macros) >= 1.429
1772#
1773%add_etc_shells(p) %{-p:<lua>}\
1774%{expand:%%lua_add_etc_shells %*}\
1775%{nil}
1776
ad17b654 1777%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1778%{-p:if arg[2] == 0 then}\
d9b789d9 1779%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1780%{-p:end} \
ad17b654
ER
1781%{nil}
1782
75bd6249
ER
1783# Check syntax for Python files
1784#
1785# Author: Elan Ruusamäe <glen@pld-linux.org>
1786# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1787#
1788# Usage:
1789# %py_lint src
1790#
1791# Requirements:
1792# BuildRequires: python
1793# BuildRequires: rpmbuild(macros) >= 1.469
1794
1795%py_lint() \
1796__py_lint() { \
1797find "$@" -type f -name '*.py' | python -c ' \
1798import sys \
1799import compiler \
1800\
1801err = 0\
1802for f in sys.stdin: \
1803 fd = open(f.strip()) \
1804 c = fd.read() \
1805 fd.close() \
1806 try: \
1807 compiler.parse(c) \
1808 except SyntaxError, e: \
1809 print "py_lint: %s: %s" % (f.strip(), e) \
1810 err = err + 1\
1811\
1812if err: \
1813 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1814 sys.exit(1) \
1815else: \
1816 print >> sys.stderr, "py_lint: Found no syntax errors." \
1817' \
1818}; __py_lint %* \
1819%{nil}
1820
f602e4a0 1821# Undos files
1822#
1823# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1824#
1825# Usage:
1826# %undos list_of_files
1827#
1828# Requirements:
1829# BuildRequires: sed >= 4.0
0b7119cc 1830# BuildRequires: rpmbuild(macros) >= 1.553
f602e4a0 1831
0b7119cc
ER
1832# NB: make sure this command stays on one line
1833%undos %{__sed} -i -e 's,\\r$,,'
f602e4a0 1834
2f79ae5a
ER
1835# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1836#
1837# Author: Elan Ruusamäe <glen@pld-linux.org>
1838#
1839# Usage:
1840# -a NAME -- add command named NAME
1841# -d NAME -- remove command named NAME
1842# -f FILE -- specify plugin configuration FILE to extract command definition from
1843#
1844# Sample:
1845# %triggerin -- nagios-nrpe
1846# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1847#
1848# %triggerun -- nagios-nrpe
1849# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1850#
1851# Requirements:
1852# BuildRequires: sed >= 4.0
d7cee36f 1853# BuildRequires: rpmbuild(macros) >= 1.552
2f79ae5a 1854%nagios_nrpe(a:d:c:f:) {\
d7cee36f 1855 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2f79ae5a 1856 %{-a:# on -a and config exists \
d7cee36f
ER
1857 if [ -f /etc/nagios/nrpe.cfg ]; then \
1858 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1859 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2f79ae5a
ER
1860 fi; \
1861 fi;} \
1862 %{-d:# on package remove, -d and config exists \
d7cee36f
ER
1863 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1864 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2f79ae5a 1865 fi;} \
d7cee36f
ER
1866 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1867 %service -q nrpe restart; \
1868 fi; \
2f79ae5a
ER
1869}%{nil}
1870
070aa9f4
ER
1871# Import or update Cacti template.
1872#
1873# Author: Elan Ruusamäe <glen@pld-linux.org>
1874#
1875# Usage:
1876# %cacti_import_template XMLFILE
1877# XMLFILE -- XML template to import
1878#
1879# Sample:
1880# %post
1881# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1882#
1883# Requires: cacti >= 0.8.7e-8
1884# BuildRequires: rpmbuild(macros) >= 1.554
1885
1886%cacti_import_template() {\
1887/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1888}%{nil}
1889
cdb82983
JK
1890# pre/post script for -upstart subpackages
1891#
1892# Author: Jacek Konieczny <jajcus@jajcus.net>
1893#
1894# Usage:
1895# %upstart_post service_name
1896# %upstart_postun service_name
1897#
1898# Sample:
1899# %post upstart
1900# %upstart_post %{name}
1901#
1902# %postun upstart
1903# %upstart_postun %{name}
1904#
1905# Requirements:
1906# BuildRequires: rpmbuild(macros) >= 1.560
1907# Requires: rc-scripts >= 0.4.3
1908
1909# migrate from init script to upstart job
1910%define upstart_post() \
1911 if [ -f /var/lock/subsys/"%1" ] ; then \
1912 /sbin/service --no-upstart "%1" stop \
1913 /sbin/service "%1" start \
1914 fi
1915
1916# restart the job after upgrade or migrate to init script on removal
1917# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1918# at this point
1919%define upstart_postun() \
1920 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1921 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1922 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1923 fi
1924
f51bfb2f 1925# vim:ts=4 sw=4 noet ft=spec
This page took 0.577129 seconds and 4 git commands to generate.